/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#include <rpc/types.h>

/*****************************************************************************
 *
 *    Copyright (C) 1995 A. Bode, S. Lamberts, T. Ludwig, C. R"oder
 *
 *    PFSLib (Parallel I/O on workstations)
 *
 *    PFSLib offers parallel access to files for a parallel application
 *    running on a cluster of workstations.
 *    It is intended but not restricted to be used in message passing
 *    applications based on PVM, NXLib, MPI, and other.
 *
 *    PFSLib consists of a LIBRARY, deamon PROGRAMS, and utility PROGRAMS.
 *
 *    PFSLib is free software; you can redistribute the LIBRARY and/or
 *    modify it under the terms of the GNU Library General Public
 *    License as published by the Free Software Foundation; either
 *    version 2 of the License, or (at your option) any later version.
 *    You can redistribute the daemon PROGRAMS and utility PROGRAMS
 *    and/or modify them under the terms of the GNU General Public
 *    License as published by the Free Software Foundation; either
 *    version 2 of the License, or (at your option) any later version.
 *
 *    PFSLib is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Library General Public License and GNU General Public License 
 *    for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License and the GNU General Public License along with this
 *    library; if not, write to the Free 
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    Contact to the authors:
 *
 *    electronic mail: pfslib@informatik.tu-muenchen.de
 *
 *    paper mail:      Prof. Dr. A. Bode
 *                     Lehrstuhl f"ur Rechnertechnik und Rechnerorganisation
 *                     Institut f"ur Informatik
 *                     Technische Universit"at M"unchen
 *                     80290 M"unchen
 *                     Germany
 *
 *    This project was partially funded by a research grant form Intel
 *    Corporation. 
 *
 *****************************************************************************/

#ifdef HPPA
#include <sys/time.h>
#include <sys/types.h>
#endif /* HPPA */

/* *********************************************************************** */
/*    communication between IOD and  PFSD                                  */
/* *********************************************************************** */


#include "global.h"


/* Flags for open() call */
typedef int pfslib_otype;
bool_t xdr_pfslib_otype();


struct errorinfo {
	int errno;
	char *errstr;
};
typedef struct errorinfo errorinfo;
bool_t xdr_errorinfo();

typedef struct {
	u_int pfslib_data_len;
	char *pfslib_data_val;
} pfslib_data;
bool_t xdr_pfslib_data();

struct pfslib_fhdl {
	int vfd;
	int how_many;
	int which;
	int mode;
};
typedef struct pfslib_fhdl pfslib_fhdl;
bool_t xdr_pfslib_fhdl();
#define IPADDRLEN 4

typedef char pfslib_ipaddr[IPADDRLEN];
bool_t xdr_pfslib_ipaddr();

struct iod_address {
	char *hname;
	int port;
	pfslib_ipaddr ipaddr;
};
typedef struct iod_address iod_address;
bool_t xdr_iod_address();

struct pfslib_fattr {
	int type;
	int amode;
	int nlink;
	int userid;
	int groupid;
	long size;
	long atime;
	long mtime;
	long ctime;
	int actual;
};
typedef struct pfslib_fattr pfslib_fattr;
bool_t xdr_pfslib_fattr();

struct iod_reqargs {
	pfslib_fhdl fh;
	bool_t mixio;
	int op;
	char *fn;
	pfslib_otype oflags;
	u_int foffs;
	u_int iolen;
	int ioID;
	char *hname;
	int uid;
	int gid;
	u_long aup_time;
	pfslib_data dhb;
};
typedef struct iod_reqargs iod_reqargs;
bool_t xdr_iod_reqargs();

struct iod_ioopargs {
	int op;
	int ioID;
	pfslib_fhdl fh;
	u_int iolen;
	pfslib_data data;
};
typedef struct iod_ioopargs iod_ioopargs;
bool_t xdr_iod_ioopargs();

struct iod_prtstatargs {
	char *filename;
};
typedef struct iod_prtstatargs iod_prtstatargs;
bool_t xdr_iod_prtstatargs();

/* *********************************************************************** */
/*     define the function results                                         */
/* *********************************************************************** */


struct iod_opres {
	u_int iolen;
	pfslib_data data;
};
typedef struct iod_opres iod_opres;
bool_t xdr_iod_opres();

struct iod_ioopres {
	int stat;
	union {
		iod_opres res;
		errorinfo err;
	} iod_ioopres_u;
};
typedef struct iod_ioopres iod_ioopres;
bool_t xdr_iod_ioopres();

/* *********************************************************************** */
/*    pfsd-program definition (for IOserver communication)                  */
/* *********************************************************************** */


#define IOD ((u_long)0x399999)
extern struct rpcgen_table iod_1_table[];
extern iod_1_nproc;
#define IOD_VERS ((u_long)1)
#define IOD_REQUEST ((u_long)1)
extern void *iod_request_1();
#define IOD_IOOP ((u_long)2)
extern iod_ioopres *iod_ioop_1();
#define IOD_EXIT ((u_long)3)
extern void *iod_exit_1();
#define IOD_PRTSTAT ((u_long)4)
extern void *iod_prtstat_1();
struct rpcgen_table {
    char	*(*proc)();
    xdrproc_t	xdr_arg;
    unsigned	len_arg;
    xdrproc_t	xdr_res;
    unsigned	len_res;
};
