/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#include <rpc/rpc.h>
#include "pfsd.h"
/*****************************************************************************
 *
 *    Copyright (C) 1995 A. Bode, S. Lamberts, T. Ludwig, C. R"oder
 *
 *    PFSLib (Parallel I/O on workstations)
 *
 *    PFSLib offers parallel access to files for a parallel application
 *    running on a cluster of workstations.
 *    It is intended but not restricted to be used in message passing
 *    applications based on PVM, NXLib, MPI, and other.
 *
 *    PFSLib consists of a LIBRARY, deamon PROGRAMS, and utility PROGRAMS.
 *
 *    PFSLib is free software; you can redistribute the LIBRARY and/or
 *    modify it under the terms of the GNU Library General Public
 *    License as published by the Free Software Foundation; either
 *    version 2 of the License, or (at your option) any later version.
 *    You can redistribute the daemon PROGRAMS and utility PROGRAMS
 *    and/or modify them under the terms of the GNU General Public
 *    License as published by the Free Software Foundation; either
 *    version 2 of the License, or (at your option) any later version.
 *
 *    PFSLib is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Library General Public License and GNU General Public License 
 *    for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License and the GNU General Public License along with this
 *    library; if not, write to the Free 
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    Contact to the authors:
 *
 *    electronic mail: pfslib@informatik.tu-muenchen.de
 *
 *    paper mail:      Prof. Dr. A. Bode
 *                     Lehrstuhl f"ur Rechnertechnik und Rechnerorganisation
 *                     Institut f"ur Informatik
 *                     Technische Universit"at M"unchen
 *                     80290 M"unchen
 *                     Germany
 *
 *    This project was partially funded by a research grant form Intel
 *    Corporation. 
 *
 *****************************************************************************/


#ifdef SUN4
#include <memory.h>
#else
#include <string.h>
#endif /* SUN4 */

#define bzero(a,b) memset(a,0,b)

/* Zero timeout */
static struct timeval ZTIMEOUT = { 0, 0 };


/* Default timeout can be changed using clnt_control() */
static struct timeval TIMEOUT = { 25, 0 };

openres *
pfsd_open_1(argp, clnt)
	openargs *argp;
	CLIENT *clnt;
{
	static openres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_OPEN, xdr_openargs, argp, xdr_openres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

setiomoderes *
pfsd_setiomode_1(argp, clnt)
	setiomodeargs *argp;
	CLIENT *clnt;
{
	static setiomoderes res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_SETIOMODE, xdr_setiomodeargs, argp, xdr_setiomoderes, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

iomoderes *
pfsd_getiomode_1(argp, clnt)
	pfslib_fhdl *argp;
	CLIENT *clnt;
{
	static iomoderes res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_GETIOMODE, xdr_pfslib_fhdl, argp, xdr_iomoderes, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

getioidres *
pfsd_getioid_1(argp, clnt)
	getioidargs *argp;
	CLIENT *clnt;
{
	static getioidres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_GETIOID, xdr_getioidargs, argp, xdr_getioidres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

iodoneres *
pfsd_iodone_1(argp, clnt)
	ioidstatargs *argp;
	CLIENT *clnt;
{
	static iodoneres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_IODONE, xdr_ioidstatargs, argp, xdr_iodoneres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

iowaitres *
pfsd_iowait_1(argp, clnt)
	ioidstatargs *argp;
	CLIENT *clnt;
{
	static iowaitres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_IOWAIT, xdr_ioidstatargs, argp, xdr_iowaitres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

ioopres *
pfsd_ioop_1(argp, clnt)
	ioopargs *argp;
	CLIENT *clnt;
{
	static ioopres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_IOOP, xdr_ioopargs, argp, xdr_ioopres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

lsizeres *
pfsd_lsize_1(argp, clnt)
	fpmoveargs *argp;
	CLIENT *clnt;
{
	static lsizeres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_LSIZE, xdr_fpmoveargs, argp, xdr_lsizeres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

iseofres *
pfsd_iseof_1(argp, clnt)
	pfslib_fhdl *argp;
	CLIENT *clnt;
{
	static iseofres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_ISEOF, xdr_pfslib_fhdl, argp, xdr_iseofres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

lseekres *
pfsd_lseek_1(argp, clnt)
	fpmoveargs *argp;
	CLIENT *clnt;
{
	static lseekres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_LSEEK, xdr_fpmoveargs, argp, xdr_lseekres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

fattrres *
pfsd_getfattr_1(argp, clnt)
	pfslib_fhdl *argp;
	CLIENT *clnt;
{
	static fattrres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_GETFATTR, xdr_pfslib_fhdl, argp, xdr_fattrres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

closeres *
pfsd_close_1(argp, clnt)
	pfslib_fhdl *argp;
	CLIENT *clnt;
{
	static closeres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_CLOSE, xdr_pfslib_fhdl, argp, xdr_closeres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

int *
pfsd_numclnts_1(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_NUMCLNTS, xdr_void, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

int *
pfsd_numfiles_1(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_NUMFILES, xdr_void, argp, xdr_int, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

resetres *
pfsd_reset_1(argp, clnt)
	resetargs *argp;
	CLIENT *clnt;
{
	static resetres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_RESET, xdr_resetargs, argp, xdr_resetres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

void *
pfsd_cltexit_1(argp, clnt)
	pfslib_fhdl *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_CLTEXIT, xdr_pfslib_fhdl, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}

void *
pfsd_prtstat_1(argp, clnt)
	prtstatargs *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_PRTSTAT, xdr_prtstatargs, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}

void *
pfsd_exit_1(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_EXIT, xdr_void, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}

void *
pfsd_iod_result_1(argp, clnt)
	iodresargs *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_IOD_RESULT, xdr_iodresargs, argp, NULL, NULL, ZTIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}

iodregres *
pfsd_iod_register_1(argp, clnt)
	iodregargs *argp;
	CLIENT *clnt;
{
	static iodregres res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, PFSD_IOD_REGISTER, xdr_iodregargs, argp, xdr_iodregres, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}
